//+------------------------------------------------------------------+
//|                                         CassLinearRegression.mqh |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
class CLinReg
   {
      private:
         double A ;//     Y=AX+B 
         double B ;//  B   Y=AX+B
         double Disp;//        
         double HitrDisp ;//       
         double Y ;//  Y  0       Y=Ax+B
         double Ugol ;//     Ugol=MathArctan(B), 0   
         double RegLin[];//      
      public:
         //void   ClinReg() ;//     
         double getA(const double& mass[]) {setABY(mass);return(A); } ;//  
         double getB(const double& mass[]) {setABY(mass);return(B); } ;//  
         double getY(const double& mass[]) {setABY(mass);return(Y); } ;// Y  0  
         double getDisp(const double& mass[]) ;//  
                                               //   
         double getHitrDisp(const double& mass[]) ;//    
                                                   //     
         double getUgol(const double& mass[]) {setABY(mass);return(MathArctan(B)*180/3.14159); } ;//    
                                                                                                  //  
         int    getLinReg(const double& mass[],double& LinRegMass[]) ;
                  //      ,LinRegMass  
         int    getLinRegStandrtDisp(const double& mass[],double Diviation,double& LinRegmass[], double& DispHighMass[],
                                     double& DispLowMass[]) ;//     
                                       //    ,LinRegmass,DispHighMass,DispLowMass   -1  
         int    getLinRegHitrDisp(const double& mass[],double Diviation,double& LinRegmass[], double& HitrDispHighMass[],
                                     double& HitrDispLowMass[]) ;//     
                                       //    ,LinRegmass,HitrDispHighMass,HitrDispLowMass   -1 
      protected:
         void  setABY(const double& mass[]);//   ,,Y
               // Y   0   
   };
//====================================================================================================================
void CLinReg::setABY(const double& mass[])
   {
      int N=ArraySize(mass),i ;
      double SummX=0 ,SummY=0 ,SummXY=0 ,SummXX=0;
      for(i=0 ;i<N ;i++)
         {
            SummX=SummX+(i+1) ;
            SummXX=SummXX+pow(i+1,2) ;
            SummY=SummY+mass[i] ;
            SummXY=SummXY+(i+1)*mass[i] ;
         }
      A=(SummX*SummY-N*SummXY)/(SummX*SummX-N*SummXX) ;
      B=(SummY-A*SummX)/N ;
      Y=A+B ;  
   };
//============================================================================================================
double CLinReg::getDisp(const double &mass[])
   {
      double SrednX=0,Summ=0 ;
      int i,N=ArraySize(mass) ;
      for (i=0;i<N;i++) SrednX+=mass[i] ;
      SrednX/=N ;
      for(i=0;i<N;i++)  Summ+=pow(mass[i]-SrednX,2)  ;
      Disp=sqrt(Summ/N) ;
      return(Disp) ;      
   };
//============================================================================================================
double CLinReg::getHitrDisp(const double &mass[])
   {
      double Summ=0 ;
      int i,N=ArraySize(mass) ;
      setABY(mass) ;
      for(i=0;i<N;i++)
         {
            Summ+=pow(B+A*(i+1)-mass[i],2) ;
         }
      HitrDisp=sqrt(Summ/N) ;
      return(HitrDisp) ;
   };
//============================================================================================================
int CLinReg::getLinReg(const double &mass[],double &RegLin[])
   {
      //double Summ=0 ;
      int i,N=ArraySize(mass);//M=ArraySize(LinRegMass) ;
      ArrayResize(RegLin,N,0) ;
      //if (N != M )return(-1) ;
      setABY(mass) ; 
      for(i=0;i<N;i++)
         { 
            //LinRegMass[i]=A*(i+1)+B  ;
            RegLin[i]=A*(i+1)+B ;
         }
      return(N) ;      
   }
//============================================================================================================
int CLinReg::getLinRegStandrtDisp(const double &mass[],double Diviation,double &LinRegmass[],double &DispHighMass[],double &DispLowMass[])
   {
      int i,N=ArraySize(mass),M=ArraySize(LinRegmass),O=ArraySize(DispHighMass),P=ArraySize(DispLowMass) ;
      if (N!=M || N!=O || N!=P) return(-1) ;
      //ArrayResize(RegLin,N,0) ;
      getLinReg(mass,RegLin) ;
      getDisp(mass) ;
      for (i=0;i<N;i++)
         {
            LinRegmass[i]=RegLin[i] ;
            DispHighMass[i]=RegLin[i]+Diviation*Disp ;
            DispLowMass[i]=RegLin[i]-Diviation*Disp ;
         }
     return(N) ;
   }
//================================================================================================================
int CLinReg::getLinRegHitrDisp(const double &mass[],double Diviation,double &LinRegmass[],double &HitrDispHighMass[],double &HitrDispLowMass[])
   {
      int i,N=ArraySize(mass),M=ArraySize(LinRegmass),O=ArraySize(HitrDispHighMass),P=ArraySize(HitrDispLowMass) ;
      if (N!=M || N!=O || N!=P) return(-1) ;
      //ArrayResize(RegLin,N,0) ;
      getLinReg(mass,RegLin) ;
      getHitrDisp(mass) ;
      for (i=0;i<N;i++)
         {
            LinRegmass[i]=RegLin[i] ;
            HitrDispHighMass[i]=RegLin[i]+Diviation*HitrDisp ;
            HitrDispLowMass[i]=RegLin[i]-Diviation*HitrDisp ;
         }
     return(N) ;
   }